---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: llm
spec:
  replicas: 1
  selector:
    matchLabels:
      app: llm
  template:
    metadata:
      labels:
        app: llm
    spec:
      initContainers:
        - name: llm-init
          image: curlimages/curl
          command: ["/bin/sh", "-c"]
          args:
            - "! [ -f /models/vicuna-13b-v1.5.Q3_K_M.gguf ] && curl -L --output-dir /models -O 'https://huggingface.co/TheBloke/vicuna-13B-v1.5-GGUF/resolve/main/vicuna-13b-v1.5.Q3_K_M.gguf?download=true' ; cp /models/vicuna-13b-v1.5.Q3_K_M.gguf /var/lib/llm"
          volumeMounts:
            - name: bot-model
              mountPath: /models
            - name: bot-model-local
              mountPath: /var/lib/llm
      containers:
        - name: llm
          image:
            "registry.ethz.ch/sis/container/llama.cpp-server/llama.cpp:2023-12-03"
          args: ["-m", "/var/lib/llm/vicuna-13b-v1.5.Q3_K_M.gguf", "--host", "0.0.0.0"]
          ports:
            - name: llm
              containerPort: 8080
          volumeMounts:
            - name: bot-model-local
              mountPath: /var/lib/llm
              readOnly: true
      volumes:
        - name: bot-model
          # Shared among multiple pods
          emptyDir: {}
        - name: bot-model-local
          # For local pod only (hopefully faster)
          emptyDir: {}
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: matrix-llm-bot
spec:
  replicas: 1
  selector:
    matchLabels:
      app: bot
  template:
    metadata:
      labels:
        app: bot
    spec:
      containers:
        - name: matrix-llm-bot
          image:
            "registry.ethz.ch/sis/experimental/matrix-llm-bot/matrix-llm-bot:2023-12-02"
          volumeMounts:
            - name: bot-config
              mountPath: /etc/matrix-llm-bot/config.toml
              subPath: config.toml
              readOnly: true
            - name: bot-state
              mountPath: /var/cache/matrix-llm-bot
      volumes:
        - name: bot-config
          secret:
            secretName: bot-config
        - name: bot-state
          emptyDir: {}
